SystemOrganization addCategory: #'Glamour-Morphic'!

Object subclass: #GLMListModel
	instanceVariableNames: 'items selection onSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMListModel methodsFor: 'accessing' stamp: 'tg 2/25/2009 16:39'!
initialize
	selection := 0! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 2/25/2009 16:32'!
items
	^items! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 2/25/2009 16:33'!
items: aCollection
	items := aCollection! !

!GLMListModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 10:55'!
listAt: anIndex
	^self items at: anIndex! !

!GLMListModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 10:54'!
listSize
	^self items size! !

!GLMListModel methodsFor: 'updating' stamp: 'david_roethlisberger 2/27/2009 11:41'!
onSelection: aBlock
	onSelection := aBlock! !

!GLMListModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 11:35'!
selection 
	^selection! !

!GLMListModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 11:42'!
selection: anIndex.
	selection := anIndex.
	onSelection ifNotNil: [onSelection value: (self listAt: anIndex)].
	self changed: #selection.! !

Object subclass: #GLMTextModel
	instanceVariableNames: 'text onTextChanged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 13:16'!
accept: aText notifying: anObject 
 	aText asString withBlanksTrimmed ifEmpty: [^self].
	"onTextChanged ifNotNil: [onTextChanged value: aText]."
	text := aText.
	self changed: #text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 12:08'!
onTextChanged: aBlock
	onTextChanged := aBlock! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 11:50'!
selection
	^ 1 to: 0! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 11:50'!
text
	^text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 11:51'!
text: aTextOrString
	text := aTextOrString! !

Object subclass: #GLMTreeModel
	instanceVariableNames: 'roots selection childrenBlock onSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:24'!
childrenBlock
	^childrenBlock! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:24'!
childrenBlock: aBlock
	childrenBlock := aBlock! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 13:56'!
geSelectionPath
	^self selection! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 14:32'!
getChildrenOf: aNode
	^childrenBlock value: aNode! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 13:56'!
getLabelOf: aStringOrText
	^ aStringOrText ! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 14:32'!
hasChildren: aNode
	^(self getChildrenOf: aNode) notEmpty! !

!GLMTreeModel methodsFor: 'private' stamp: 'david_roethlisberger 2/27/2009 14:12'!
nodeAt: pathCollection
	^self nodeAt: pathCollection allButFirst for: self roots! !

!GLMTreeModel methodsFor: 'private' stamp: 'david_roethlisberger 2/27/2009 14:26'!
nodeAt: pathCollection for: childrenCollection
	| node |
	node := childrenCollection at: pathCollection first.
	^pathCollection size > 1 ifTrue: [self nodeAt: pathCollection allButFirst for: (childrenBlock value: node)] ifFalse: [node]! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:38'!
onSelection: aBlock
	onSelection := aBlock! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 13:54'!
roots
	^roots! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:22'!
roots: aCollectionOrElement
	roots := aCollectionOrElement isCollection ifTrue: [aCollectionOrElement] ifFalse: [OrderedCollection with: aCollectionOrElement]! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 13:57'!
selection
	^selection! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 14:39'!
selection: aNode
     selection := aNode.
	onSelection ifNotNil: [onSelection value: aNode].
	self changed: #selection.! !

GLMRenderer subclass: #GLMMorphicRenderer
	instanceVariableNames: 'fixedFinderRenderHelper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicRenderer commentStamp: 'tg 2/25/2009 15:57' prior: 0!
browser := GLMTableLayoutBrowser new.
browser column: #one; column: #two.

browser showOn: #one; using: [browser list.].
browser showOn: #two; from: #one; using: [
	browser text.].
browser openOn: #(a b c d)!

!GLMMorphicRenderer methodsFor: 'opening' stamp: 'david_roethlisberger 2/26/2009 15:25'!
doOpen: aUI 

	^GlamorousSystemWindow openOn: aUI! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'tg 2/25/2009 14:00'!
fixedFinderRenderHelper 
	 
	^fixedFinderRenderHelper 
		ifNil: 
			[fixedFinderRenderHelper := FixedFinderRenderHelper new renderer: self]! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'david_roethlisberger 2/27/2009 13:18'!
installActionsOnUI: text fromPresentation: aTextPresentation 
	 
	"aTextPresentation actions 
		do: 
			[:each |  
			text keymap 
				map: (Keystroke ctrl: each shortcut) 
				to: (#action , each shortcut asSymbol) asSymbol. 
			text 
				addAction: 
					(Action 
						id: (#action , each shortcut asSymbol) asSymbol 
						action: [each actOn: aTextPresentation pane])]"! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'david_roethlisberger 2/27/2009 10:49'!
renderCustomColumn: aCell ofPane: aPane inUI: aUIContainer inBrowser: aBrowser 
	 
	| panes pane glamourPane totalSpans currentSpanPosition | 
	totalSpans := aCell children sum: #span. 
	currentSpanPosition := 0. 
	panes := aCell children 
		collectWithIndex: 
			[:each :index |  
			each hasId 
				ifFalse: 
					[pane := RectangleMorph new. 
					self renderCustomRow: each ofPane: aPane inUI: pane inBrowser: 
							aBrowser] 
				ifTrue: 
					[glamourPane := aBrowser paneNamed: each id. 
					pane := glamourPane renderGlamorouslyOn: self	"glamourPane onPortValueChange: [:announcement | aPane portValueAt: announcement portName put: announcement portValue]."]. 
			"pane cellPositioning: #topLeft.	"	
			aUIContainer addMorph: pane. 
			"pane 
				frame: 
					(FractionalFrame 
						fractionLeft: 0 
						right: 1 
						top: currentSpanPosition / totalSpans 
						bottom: (currentSpanPosition + each span) / totalSpans). "
			currentSpanPosition := currentSpanPosition + each span. 
			pane]. 
	"1 
		to: panes size - 1 
		do: 
			[:index |  
			topPane := panes at: index. 
			splitter := ResizingSplitter new. 
			splitter 
				frame: 
					((FractionalFrame 
						fractionLeft: 0 
						right: 1 
						top: topPane frame bottomFraction 
						bottom: topPane frame bottomFraction) setOffsetLeft: 0 top: -2 right: 
							0 bottom: 2). 
			splitter beHorizontal. 
			splitter topWidgets: (OrderedCollection with: (panes at: index) id). 
			splitter 
				bottomWidgets: (OrderedCollection with: (panes at: index + 1) id). 
			aUIContainer addComponent: splitter]"! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'david_roethlisberger 2/27/2009 11:27'!
renderCustomRow: aCell ofPane: aPane inUI: aUIContainer inBrowser: aBrowser 
	 
	| panes pane glamourPane totalSpans currentSpanPosition | 
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ]. 
	currentSpanPosition := 0.
	panes := aCell children 
		collectWithIndex: 
			[:each :index |  
			each hasId 
				ifFalse: 
					[pane := RectangleMorph new. 
					pane 
						layoutPolicy: TableLayout new;
						listDirection: #leftToRight;
						cellPositioning: #topLeft;
						borderWidth: 0;
						hResizing: #spaceFill;
						vResizing: #spaceFill;		
						wrapCentering: #center;
						rubberBandCells: false;
						layoutInset: 2;
						cellInset: 2;
						color: Color white.	
					self renderCustomColumn: each ofPane: aPane inUI: pane inBrowser: aBrowser] 
				ifTrue: 
					[glamourPane := aBrowser paneNamed: each id. 
					pane := glamourPane renderGlamorouslyOn: self.
					"glamourPane onPortValueChange: [:announcement | aPane portValueAt: announcement portName put: announcement portValue]"
					]. 
			aUIContainer addMorphBack: pane. 
			pane]. 
"	1 
		to: panes size - 1 
		do: 
			[:index |  
			leftPane := panes at: index. 
			splitter := BorderedSubpaneDividerMorph new. 

			splitter vertical. 
			
			aUIContainer addMorph: splitter]"
		! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 2/25/2009 14:00'!
renderFinder: aBrowser 
	 
	| container | 
	container := Form new. 
	container 
		frame: (FractionalFrame fractionLeft: 0 right: 1 top: 0 bottom: 1). 
	container horizontalScrollbar: true. 
	aBrowser 
		when: PaneRemoved 
		do: [:ann | container removeComponent: container components last]. 
	aBrowser 
		when: PaneAdded 
		do: 
			[:ann |  
			self 
				renderPane: ann pane 
				inFinder: container. 
			container 
				contentsExtent: 
					(container components last frame windowRelativeBounds right + 10) @ 400. 
			container 
				scrollHorizontally: 
					container components last frame windowRelativeBounds right + 10]. 
	aBrowser panes do: [:each | self renderPane: each inFinder: container]. 
	^container! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 2/25/2009 14:00'!
renderFixedFinder: aBrowser 
	 
	^self fixedFinderRenderHelper render: aBrowser	" 
	| container uiPane | 
	container := Widgetry.Form new. 
	container frame: Widgetry.FractionalFrame fullyAttached. 
	 
	aBrowser onPaneRemoved: [ :ann | 
		container removeComponent: container components last. 
	]. 
	aBrowser onPaneAdded: [ :ann | 
		uiPane := (ann pane renderGlamorouslyOn: self). 
		container components size > 1 ifTrue: [ 
			container removeComponent: container components first. 
			container components last frame: (Widgetry.FractionalFrame fractionLeft: 0 top: 0 right: 0.5 bottom: 1).		 
		]. 
		uiPane frame: (Widgetry.FractionalFrame fractionLeft: 0.5 top: 0 right: 1 bottom: 1).	 
		container addComponent: uiPane. 
	]. 
	aBrowser panes doWithIndex: [:each :index | 
		uiPane := (each renderGlamorouslyOn: self).		 
		uiPane frame: (Widgetry.FractionalFrame fractionLeft: (index - 1) * 0.5 top: 0 right: index * 0.5 bottom: 1). 
		container addComponent: uiPane. 
	]. 
	^container 
"! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'david_roethlisberger 2/27/2009 13:24'!
renderListPresentation: aListPresentation 
	 
	| items list toShow listModel | 
	toShow := aListPresentation displayValue. 
	items := toShow isCollection 
		ifTrue: [toShow] 
		ifFalse: [Array with: toShow]. 
		
	listModel := GLMListModel new items: ((items ifNil: [OrderedCollection new]) collect: [:e | e perform: aListPresentation format]); yourself.	
	list := PluggableListMorph on: listModel list: #items selected: #selection changeSelected: #selection:.
	list	
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		getListElementSelector: #listAt:;
		getListSizeSelector: #listSize;
		borderWidth: 1;
		autoDeselect: false.
	self installActionsOnUI: list fromPresentation: aListPresentation.
	listModel onSelection: [:selection | aListPresentation selection: selection]. 
	aListPresentation 
		whenContextChanged: 
			[:ann | ann property = #selection ifTrue: [list selection: ann value]]. 
	list vShowScrollBar.	
	^list! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 2/25/2009 14:00'!
renderMondrianPresentation: aMondrianPresentation 
	 
	| canvas view form | 
	view := aMondrianPresentation renderView. 
	canvas := MondrianCanvas new. 
	canvas frame: FractionalFrame fullyAttached. 
	canvas renderer: view. 
	canvas 
		when: SelectionChanged 
		do: [:ann | aMondrianPresentation selection: canvas selection]. 
	form := MooseForm new. 
	form addComponent: canvas. 
	form frame: FractionalFrame fullyAttached. 
	aMondrianPresentation 
		whenContextChanged: 
			[:ann |  
			ann property = #selection 
				ifTrue: 
					[canvas artist drawing deepNodeFigures do: [:each | each deselect]. 
					(canvas artist drawing deepFindNodeWithEntity: ann value) 
						ifNotNil: [:figure | figure fixedSelect]]]. 
	^form! !

!GLMMorphicRenderer methodsFor: 'rendering' stamp: 'david_roethlisberger 2/27/2009 11:44'!
renderPane: aPane 
	 
	| container topOffset inspectButton label | 
	container := RectangleMorph new. 
	container				 
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		cellPositioning: #topLeft;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		rubberBandCells: false;
		layoutInset: 2;
		cellInset: 2;
		color: Color white.		

	topOffset := 0. 
	(aPane matchingPresentations anySatisfy: [:each | each isInspectable]) 
		ifTrue: 
			[topOffset := 28.  
			label := PluggableTextMorph new. 
			label layoutInset: 2. 
			label setText: (aPane port: #entity) value displayString. 
			inspectButton := PluggableButtonMorph new. 
			"inspectButton 
				frame: 
					(LayoutFrame new 
						leftFraction: 0; 
						topFraction: 0; 
						rightFraction: 1; 
						bottomFraction: 0; 
						bottomOffset: 24;
						yourself). "
			inspectButton label: (aPane port: #entity) value displayString.
			"inspectButton 
				when: Clicked 
				do: [(aPane port: #entity) value inspect]. "
			container addMorphBack: inspectButton]. 
	container addMorphBack: (self renderPresentationsOf: aPane).	
	aPane 
		whenMatchingPresentationsChanged: 
			[:announcement |  
			container removeAllMorphs. 
			container addMorph: (self renderPresentationsOf: aPane)]. 
	^container! !

!GLMMorphicRenderer methodsFor: 'private-finder' stamp: 'tg 2/25/2009 14:00'!
renderPane: aPane inFinder: container 
	 
	| uiPane | 
	uiPane := aPane renderGlamorouslyOn: self. 
	container components isEmpty 
		ifFalse: 
			[uiPane 
				frame: 
					(InsetExtentFrame 
						inset: 
							(container components last frame windowRelativeBounds right + 4) @ 0 
						extent: 390 @ 500)	"				((FractionalFrame fractionLeft: 0 right: 0 top: 0 bottom: 1)  
					leftOffset: (container components last frame rightOffset + 4); 
					rightOffset: (container components last frame rightOffset + 4) + 500) 
"] 
		ifTrue: 
			[uiPane 
				frame: 
					(InsetExtentFrame 
						inset: 4 @ 0 
						extent: 390 @ 500)	"					((FractionalFrame fractionLeft: 0 right: 0 top: 0 bottom: 1) rightOffset: 500) 
"]. 
	container addComponent: uiPane! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'david_roethlisberger 2/27/2009 11:28'!
renderPresentationsOf: aPane 
	 
	| presentations | 
	presentations := OrderedCollection new. 
	aPane matchingPresentations 
		do: 
			[:each |  
			(each renderGlamorouslyOn: self) 
				ifNotNil: [:ui | presentations addLast: each title -> ui]]. 
	presentations size < 1 ifTrue: [^RectangleMorph new width: 1; height: 1; cellPositioning: #topLeft; yourself]. 
	presentations size = 1 ifTrue: [^presentations first value]. 
	
	
	"tabs := TabControl new. 
	tabs frame: FractionalFrame fullyAttached. 
	presentations 
		do: 
			[:each |  
			form := RectangleMorph new. 
			each value frame: FractionalFrame fullyAttached. 
			form addComponent: each value. 
			tabs 
				addPage: form 
				label: each key]. 
	tabs showPage: 1. 
	^tabs"! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'david_roethlisberger 2/27/2009 10:48'!
renderTableLayoutBrowser: aBrowser 
	 
	| container | 
	container := RectangleMorph new. 
	container 
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		rubberBandCells: false;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.	
	aBrowser cell isRow 
		ifTrue: 
			[self 
				renderCustomRow: aBrowser cell 
				ofPane: aBrowser pane 
				inUI: container 
				inBrowser: aBrowser] 
		ifFalse: 
			[self
				renderCustomColumn: aBrowser cell 
				ofPane: aBrowser pane 
				inUI: container 
				inBrowser: aBrowser].
	^container! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'david_roethlisberger 2/27/2009 13:16'!
renderTextPresentation: aTextPresentation 
	 
	| textMorph toShow textModel | 
	toShow := aTextPresentation formatedDisplayValue. 
	textModel := GLMTextModel new text: toShow.
	textModel onTextChanged: [:text | aTextPresentation text: text].
	
	textMorph := (PluggableTextMorph 
		on: textModel
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
			font: Preferences standardCodeFont;
			hideScrollBarsIndefinitely;
			acceptOnCR: true;
			height: Preferences standardCodeFont height * 1.2;
			borderWidth: 0;
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			borderWidth: 1;
			cellPositioning: #topLeft;
			yourself.
	self installActionsOnUI: textMorph fromPresentation: aTextPresentation.
"	text 
		when: ValueChanged 
		do: [:ann | aTextPresentation text: ann newValue]. "
	^textMorph! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'david_roethlisberger 2/27/2009 14:41'!
renderTreePresentation: aTreePresentation	 
	| toShow treeMorph treeModel | 
	
	toShow := aTreePresentation displayValue. 
	treeModel := GLMTreeModel new roots: toShow; yourself.
	treeModel childrenBlock: aTreePresentation children.
	
	treeMorph := PluggableTreeMorph new
		model: treeModel;
		getLabelSelector: #getLabelOf:;		
		getSelectedPathSelector: #getSelectionPath;				
		getChildrenSelector: #getChildrenOf:;
		hasChildrenSelector: #hasChildren:;
		setSelectedSelector: #selection:;					
		getRootsSelector: #roots;
		vResizing: #spaceFill;
		hResizing: #spaceFill;		
		borderWidth: 0;
		autoDeselect: false;
		yourself.

	treeModel onSelection: [:selection | aTreePresentation selection: selection]. 
	treeMorph vShowScrollBar.	
	^treeMorph! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 2/25/2009 14:00'!
renderWorkspacePresentation: aWorkspacePresentation 
	 
	| pane result textToInsert position anObject | 
	anObject := aWorkspacePresentation pane input. 
	pane := TextEdit new. 
	pane keymap 
		map: (Keystroke ctrl: $o) 
		to: #doItAndSelect. 
	pane 
		addAction: 
			(Action 
				id: #doItAndSelect 
				action: 
					[result := self workspaceEvaluateSelectionFrom: anObject for: pane. 
					pane announce: (SelectionChanged new newValue: result)]). 
	pane keymap 
		map: (Keystroke ctrl: $q) 
		to: #doItAndInspect. 
	pane 
		addAction: 
			(Action 
				id: #doItAndInspect 
				action: 
					[result := self workspaceEvaluateSelectionFrom: anObject for: pane. 
					result inspect]). 
	pane keymap 
		map: (Keystroke ctrl: $d) 
		to: #doIt. 
	pane 
		addAction: 
			(Action 
				id: #doIt 
				action: 
					[result := self workspaceEvaluateSelectionFrom: anObject for: pane]). 
	pane keymap 
		map: (Keystroke ctrl: $p) 
		to: #doItAndPrint. 
	pane 
		addAction: 
			(Action 
				id: #doItAndPrint 
				action: 
					[result := self workspaceEvaluateSelectionFrom: anObject for: pane. 
					textToInsert := result printString. 
					position := pane agent insertionPosition. 
					pane insertAtCurrentPosition: textToInsert. 
					pane setInsertionPointAt: position. 
					pane extendSelectionByCharacters: textToInsert size]). 
	pane verticalScrollbar: true. 
	pane wordWrapped: true. 
	^pane! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'tg 2/25/2009 14:00'!
workspaceEvaluateSelectionFrom: anObject for: pane 
	 
	| bindings result namespaces text | 
	namespaces := Root allNameSpaces copyWithout: Undeclared. 
	bindings := NameSpace new 
		importsObjects: 
			(namespaces 
				collect: [:each | GeneralNameSpaceImport pathString: each fullName]). 
	bindings simpleAddBinding: (VariableBinding key: #entity value: anObject). 
	pane selection isEmpty 
		ifTrue: 
			[pane agent setInsertionPointToBeginningOfLine. 
			pane selectCurrentLine]. 
	text := pane selection. 
	result := Compiler evaluate: text for: nil in: bindings notifying: nil 
		logged: false. 
	^result! !
